dialog twtest {
  title "TreeViewTest"
  size -1 -1 200 150
  option dbu
  button "Close", 1, 75 132 50 12, ok cancel
  list 2, 10 10 80 114, size hsbar vsbar
  box "Basic Information", 3, 95 10 100 55
  text "Line:", 4, 105 22 25 8
  text "ID:", 5, 105 32 25 8
  text "Text:", 6, 105 42 25 8
  text "Parent:", 7, 105 52 25 8
  text "", 8, 140 22 50 8
  text "", 9, 140 32 50 8
  text "", 10, 140 42 50 8
  text "", 11, 140 52 50 8
  box "Random stuff", 12, 95 70 100 55
  button "Select [IRC]", 13, 105 85 37 12
  button "Toggle [DCC]", 14, 150 85 37 12
  button "Reset", 15, 105 105 37 12
  button "Delete Sel.", 16, 150 105 37 12
}
alias tree {
  dialog $iif($dialog(twtest),-v,-m twtest) twtest
}
on *:dialog:twtest:*:*: {
  if ($devent == sclick) {
    ; the listbox was clicked -> update information
    if ($did == 2) {
      var %sel = $did($dname,$did).sel
      did -ra $dname 8  %sel
      did -ra $dname 9  $tw.id(%sel)
      did -ra $dname 10 $tw.id(%sel).text
      did -ra $dname 11 $tw.id(%sel).parent
    }

    ; Select [IRC]
    elseif ($did == 13) {
      var %sel = $tw.id(irc-parent, 2).line
      did -c $dname 2 %sel

      ; Update Information
      did -ra $dname 8  %sel
      did -ra $dname 9  $tw.id(%sel, 2)
      did -ra $dname 10 $tw.id(%sel, 2).text
      did -ra $dname 11 $tw.id(%sel, 2).parent
    }

    ; Toggle [DCC]
    elseif ($did == 14) {
      tw.toggle $dname 2 dcc-parent

      ; Update Information
      var %sel = $did($dname, 2).sel
      did -ra $dname 8  %sel
      did -ra $dname 11 $tw.id(%sel, 2).parent
    }

    ; Reset
    elseif ($did == 15) {
      tw.erase $dname 2
      twtest-init-commands

      ; Update Information
      did -r $dname 8-11
    }

    ; Delete Sel.
    elseif ($did == 16) && ($did($dname,2).sel) {
      var %sel = $did($dname,2).sel
      tw.del $dname 2 $tw.id(%sel, 2)

      ; Update Information
      did -r $dname 8-11
    }
  }

  ; listbox was double-clicked
  elseif ($devent == dclick) && ($did == 2) {
    ; Update Information
    var %sel = $did($dname,2).sel
    did -ra $dname 11 $tw.id(%sel, 2).parent
  }

  elseif ($devent == init) {
    twtest-init-commands
  }
}
alias -l twtest-init-commands {
  tw.init -z twtest 2



  ; /tw.add   <DNAME>   <DID>   <ID>             <PARENT-ID>      <POSITION>   <IS-PARENT>   <TEXT>
  tw.add      twtest    2       connect-parent   0                0            1             Connect

  tw.add      twtest    2       co.servers       connect-parent   0            0             Servers
  tw.add      twtest    2       co.options       connect-parent   0            0             Options
  tw.add      twtest    2       co.local         connect-parent   0            0             Local Info
  tw.add      twtest    2       co.identd        connect-parent   0            0             Identd
  tw.add      twtest    2       co.firewall      connect-parent   0            0             Firewall



  ; [ IRC ] will be expanded automatically, because IS-PARENT = 2
  tw.add twtest 2 irc-parent 0 0 2 IRC

  tw.add twtest 2 irc.options irc-parent 0 0 Options
  tw.add twtest 2 irc.messages irc-parent 0 0 Messages
  tw.add twtest 2 irc.catcher irc-parent 0 0 Catcher
  tw.add twtest 2 irc.logging irc-parent 0 0 Logging
  tw.add twtest 2 irc.flood irc-parent 0 0 Flood



  tw.add twtest 2 sounds-parent 0 0 1 Sounds
  tw.add twtest 2 sounds.requests sounds-parent 0 0 Requests
  tw.add twtest 2 sounds.agents sounds-parent 0 0 Agents



  tw.add twtest 2 mouse-parent 0 0 1 Mouse
  tw.add twtest 2 mouse.drag mouse-parent 0 0 Drag Drop



  tw.add twtest 2 dcc-parent 0 0 1 DCC

  tw.add twtest 2 dcc.options dcc-parent 0 0 Options
  tw.add twtest 2 dcc.folders dcc-parent 0 0 Folders
  tw.add twtest 2 dcc.ignore dcc-parent 0 0 Ignore
  tw.add twtest 2 dcc.fserve dcc-parent 0 0 Fserve
  tw.add twtest 2 dcc.server dcc-parent 0 0 Server
  ; Let's expand [ DCC ], too
  tw.exp twtest 2 dcc-parent



  tw.add twtest 2 display-parent 0 0 1 Display
  tw.add twtest 2 display.options display-parent 0 0 Options



  tw.add twtest 2 other-parent 0 0 1 Other
  tw.add twtest 2 other.lock other-parent 0 0 Lock
}